#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#ifdef _OPENMP
#include <omp.h>
#endif

int main(int argc, char* argv[]) {
	int n = 100 << 20;
	double low = 0.0;
	double high = 1.0;

	double* values = (double*)malloc(sizeof(double)*n);
	
	srand(time(NULL));
	for (int i = 0; i < n; ++i) {
		values[i] = (low + ((double) rand() / ((double) RAND_MAX + 1)) * (high - low));
	}

    int histogram[10] = {0};

    double start = omp_get_wtime();

    for (int i = 0; i < 10; ++i) {
    	#pragma omp parallel for schedule(guided) 
    	for (int j = 0; j < n; ++j) {
         	if ( values[j] >= (0.1 * i) && values[j] < (0.1 * (i+1)) ) {
         		#pragma omp atomic
            	histogram[i]++;
         	}
      	} 
   	}

   	double elapsed = omp_get_wtime() - start;

   	for (int i = 0; i < 10; ++i) {
   		printf("%.1lf - %.1lf | %d | ", (0.1 * i), (0.1 * (i+1)), histogram[i]);
   		
   		for(int j = 0; j < histogram[i] / (n/1000); ++j) {
   			printf("*");
   		}

   		printf("\n");
   	}

   	printf("\n** time = %.6lf\n", elapsed);

   	return 0;
}