#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


int main(int argc, char* argv[]) {
  const int n = 1000;
  
  int max_threads = omp_get_max_threads();
  int* iterations = malloc(sizeof(int)*max_threads);
  
  for(int i = 0; i < max_threads; ++i) 
    iterations[i] = 0;

  #pragma omp parallel
  {
    int      tid = omp_get_thread_num();
    int nthreads = omp_get_num_threads();

    int  low = n * tid / nthreads;
    int high = n * (tid + 1) / nthreads;

    for(int i = low; i < high; ++i)
      iterations[tid]++;
  }

  for(int i = 0; i < max_threads; ++i)
    printf("Number of iteration for thread %d: %d\n", i, iterations[i]);

  return 0;
}