#include <stdlib.h>
#include <stdio.h>

#include <omp.h>

void ax(int n, double alpha, double* x) {
  int nthreads = omp_get_num_threads();
  int tid = omp_get_thread_num();

  printf("Executing ax by thread %d of %d threads.\n", tid, nthreads);
  
  int niters = 0;

  #pragma omp for
  for (int i = 0; i < n; ++i) {
    x[i] = alpha * x[i];
    niters++;
  }

  printf("Thread with id %d did %d iterations.\n", tid, niters);
}

int main ( int argc, char *argv[] ) {
  int n = 1000;

  double* x = (double*)malloc(n * sizeof(double));
  double* y = (double*)malloc(n * sizeof(double));

  for (int i = 0; i < n; ++i) {
    x[i] = 2.0 * i;
    y[i] = 4.0 * i;
  }

  #pragma omp parallel 
  {
    ax(n, 3.0, x);
  }

  ax(n, 5.0, y);

  free(x);
  free(y);

  return 0;
}

