    program main
      use omp_lib

      implicit none

      integer, parameter :: n = 100
      
      integer :: tid, local_sum, local_max, i
      integer :: global_sum = 0, global_max = 0
      integer :: a(n)
    
      !$omp parallel do
        do i = 1,n
          a(i) = i
        end do
      !$omp end parallel do
      
      !$omp parallel shared(global_max, global_sum) private(tid, local_sum, local_max)
        tid = omp_get_thread_num()
        local_sum = 0
        local_max = 0
      
        !$omp do
          do i = 1,n
            local_sum = local_sum + a(i)
            local_max = max(local_max, a(i))
          end do
        !$omp end do
      
        !$omp critical (sum)
          global_sum = global_sum + local_sum;
          print 100, tid, 'sum', local_sum, 'sum', global_sum
        !$omp end critical (sum)
    
        !$omp critical (max)
          global_max = max(global_max, local_max)
          print 100, tid, 'max', local_max, 'max', global_max
        !$omp end critical (max)
      !$omp end parallel
    
      print 200, 'Sum', global_sum
      print 200, 'Max', global_max

100   format('Thread ', i0, ': local ', a,' = ', i0, ', ', a, ' = ', i0, '.')
200   format(a, ' after parallel region: ', i0)
    end program