
    program main
      use omp_lib
    
      integer, parameter :: n = 2**20
      integer, parameter :: line_size = 1
    
      integer i, max_threads, tid
    
      double precision :: elapsed, final_sum
      double precision, dimension(:), allocatable :: x, y, local_sum
    
      max_threads = omp_get_max_threads()
    
      allocate(x(n), y(n), local_sum(0:line_size*max_threads-1))
    
      do i = 1,n
        x(i) = dble(i)
        y(i) = dble(-i)
      end do
    
      final_sum = 0.0d0;
      elapsed = -1.0*omp_get_wtime()
        
      !$omp parallel shared(sum) private(tid)
        tid = omp_get_thread_num()
        local_sum(tid*line_size) = 0.0d0
    
        !$omp do
          do i = 1,n
            local_sum(tid*line_size) = local_sum(tid*line_size) &
&                                           + 0.5 * x(i) + y(i)
          end do
        !$omp end do
    
        !$omp atomic
          sum = sum + local_sum(tid*line_size)
        !$omp end atomic
      !$omp end parallel
    
      elapsed = elapsed + omp_get_wtime()
    
      print 100, elapsed
100   format('Elapsed time = ', f12.6, ' s')
        
      deallocate(x, y, local_sum)
    end program