! This sample code demonstrates the use of orphaned directive

    program main
      use omp_lib

      implicit none
    
      integer, parameter :: n = 1000
    
      double precision, dimension(:), allocatable :: x
      double precision, dimension(:), allocatable :: y

      integer :: i
    
      allocate(x(n))
      allocate(y(n))
    
      do i = 1,n
        x(i) = 2.0d0 * i
        y(i) = 4.0d0 * i
      end do
    
      !$omp parallel
        call ax(n, 3.0d0, x)
      !$omp end parallel

      call ax(n, 5.0d0, y)

      deallocate(x, y)

      contains
        subroutine ax(n, alpha, x)
          integer, intent(in)             :: n
          double precision, intent(in)    :: alpha
          double precision, intent(inout) :: x(:)
          
          integer :: i, nthreads, tid, niters

          nthreads = omp_get_num_threads()
          tid = omp_get_thread_num()

          print 100, tid, nthreads
100       format('Executing ax by thread ', i0,' of ', i0, ' threads.')

          !$omp do
            do i = 1,n
              x(i) = alpha * x(i)
              niters = niters + 1
            end do
          !$omp end do

          print 200, tid, niters
200       format('Thread with id ', i0,' did ', i0, ' iterations.')
      end subroutine
    end program

