
    program main
      use omp_lib

      implicit none

      integer, parameter :: low = 1
      integer, parameter :: high = 524288
      integer, parameter :: factor = 2
    
      integer :: primes, nthreads, n
    
      double precision :: time1, time2, time3, time4
    
      nthreads = omp_get_max_threads()
      print 100, nthreads
100   format('Number of threads = ', i0)
    
      print*, ''
      print*, '                          Default        Static       Dynamic        Guided'
      print*, '        N     Pi(N)          Time          Time          Time          Time'
      print*, ''
    
      n = low
    
      do while (n <= high)
        time1 = omp_get_wtime()
        primes = prime(n, omp_sched_static, 0)
        time1 = omp_get_wtime() - time1
    
        time2 = omp_get_wtime()
        primes = prime(n, omp_sched_static, 100)
        time2 = omp_get_wtime() - time2
    
        time3 = omp_get_wtime()
        primes = prime(n, omp_sched_dynamic, 100)
        time3 = omp_get_wtime() - time3
    
        time4 = omp_get_wtime()
        primes = prime(n, omp_sched_guided, 100)
        time4 = omp_get_wtime() - time4
      
        print 200, n, primes, time1, time2, time3, time4
200     format(2(2x,i8), 4(2x,f12.6))
    
        n = n * factor
      end do
    
      print*, ''

    contains

      function prime(n, sched, chunk)
        integer (kind=omp_sched_kind) :: sched 
        integer :: n, chunk, isprime, i, j, prime
        integer :: nprime = 0

        call omp_set_schedule(sched, chunk)

        !$omp parallel shared(n) private(isprime) 
          !$omp do reduction (+:prime) schedule(runtime)
            do i = 2,n
              isprime = 1

              do j = 2,i-1
                if ( mod(i, j) .eq. 0 ) then
                  isprime = 0
                  exit
                end if
              end do

              nprime = nprime + isprime
              end do
          !$omp end do
        !$omp end parallel

        prime = nprime
      end function
    end program